from xml.sax.saxutils import escape as xmlEscape
from httplib import HTTPConnection
from urllib import urlopen
from lxml.etree import parse, tostring, ElementTree
import sys

## oai bron van de ddi's ##
#url = "http://dvn.iq.harvard.edu/dvn/OAIHandler?verb=ListRecords&set=neeo&metadataPrefix=ddi"
#url = "http://dvn.iq.harvard.edu/dvn/OAIHandler?verb=GetRecord&identifier=hdl:1902.1/12942&metadataPrefix=ddi"
#url = "http://dvn.iq.harvard.edu/dvn/OAIHandler?verb=GetRecord&identifier=hdl:1902.1/13041&metadataPrefix=ddi"
url = "http://dvn.iq.harvard.edu/dvn/OAIHandler?verb=GetRecord&identifier=hdl:1902.1/12935&metadataPrefix=ddi"

## reader die info geeft over het document waaraan de ddi wordt toegevoegd ##
baseurl = "http://localhost:28084/sru"

action = "replace"
#action = "delete"

def send(recordUpdate):
    ## writer waarnaar de ddi wordt gestuurd ##
    # FIXME nog niet geimplementeerd:
    #   afhankelijk van collectie|repositoryGroup|repository
    #   wordt de juiste writer geselecteerd
    connection = HTTPConnection('localhost', '9999')
    connection.putrequest("POST", "/update")
    connection.putheader("Host", "localhost")
    connection.putheader("Content-Type", "text/xml; charset=\"utf-8\"")
    connection.putheader("Content-Length", str(len(recordUpdate)))
    connection.endheaders()
    connection.send(recordUpdate)

    result = connection.getresponse()
    print result.read()

def makeDocument(meta, codeBook):
    return """<document xmlns="http://meresco.com/namespace/harvester/document">
  <part name="meta">%(m)s</part>
  <part name="ddi">%(c)s</part>
</document>""" % {'m': xmlEscape(meta), 'c': xmlEscape(codeBook)}

def makeRequest(action, repository, recordIdentifier, document):
    if action == "replace":
        re = """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="http://www.loc.gov/zing/srw/" xmlns:ucp="http://www.loc.gov/ucp">
 <srw:version>1.0</srw:version>
 <ucp:action>info:srw/action/1/replace</ucp:action>
 <ucp:recordIdentifier>%(repository)s:%(recordIdentifier)s</ucp:recordIdentifier>
 <srw:record>
  <srw:recordPacking>xml</srw:recordPacking>
  <srw:recordSchema>document</srw:recordSchema>
  <srw:recordData>%(document)s</srw:recordData>
 </srw:record>
</srw:updateRequest>"""
    elif action == "delete":
        re = """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="http://www.loc.gov/zing/srw/" xmlns:ucp="http://www.loc.gov/ucp">
 <srw:version>1.0</srw:version>
 <ucp:action>info:srw/action/1/delete</ucp:action>
 <ucp:recordIdentifier>%(repository)s:%(recordIdentifier)s</ucp:recordIdentifier>
</srw:updateRequest>"""
    # the request is finished by replacing the variables by its values
    return re %locals()

def makeMeta(collection, repositoryGroup, repository, recordIdentifier, parts):
    p = ""
    if parts:
        for part in parts:
            if part == "ddi": continue
            p += "<meta:part>" + part + "</meta:part>"
    return """<meta:meta xmlns:meta="http://meresco.com/namespace/harvester/meta">
  <meta:upload><id>%(repository)s:%(recordIdentifier)s</id></meta:upload>
  <meta:record>
    <meta:id>%(recordIdentifier)s</meta:id>
  </meta:record>
  <meta:repository>
    <meta:id>%(repository)s</meta:id>
    <meta:repositoryGroupId>%(repositoryGroup)s</meta:repositoryGroupId>
    <meta:collection>%(collection)s</meta:collection>
  </meta:repository>
  <meta:parts>
    <meta:part>ddi</meta:part>
    %(p)s
  </meta:parts>
</meta:meta>""" %locals()

ns = {'ddi':'http://www.icpsr.umich.edu/DDI',
      'meta':'http://meresco.com/namespace/harvester/meta',
      'srw':'http://www.loc.gov/zing/srw/'}

xml = parse(urlopen(url))
codeBooks = xml.xpath("//ddi:codeBook", ns)
for codeBook in codeBooks:
    codeBook = ElementTree(codeBook)
    #print tostring(codeBook, pretty_print=True)
    relPubls = codeBook.xpath("/ddi:codeBook/ddi:stdyDscr/ddi:othrStdyMat/ddi:relPubl/text()", ns)
    for relPubl in relPubls:

        ## uit relPub identifier van publicatie halen ##
        #print relPubl
        # toch maar eens een reguliere expressie gebruiken?
        eo = "economistsonline.org/publications/?id="
        loceo = relPubl.find(eo)
        if loceo < 0 : 
            eo = "economistsonline.org/publications?id="
            loceo = relPubl.find(eo)
        if loceo < 0: continue
        s = relPubl[loceo + len(eo):]
        # single quotes?
        locquote = s.find('\"')
        identifier = ""
        if locquote > 0: identifier = s[:locquote]
        else: identifier = s
        identifier = identifier.strip()
        #print "identifier = " + identifier + "|"
        # we zoeken alleen op de record identifier uit het pubid
        query = "meta.record.id%20exact%20%22" + identifier.split(':', 1)[1] + "%22"

        ## informatie over publicatie ophalen ##
        sruResponse = parse(urlopen(baseurl + "?version=1.1&operation=searchRetrieve&x-recordSchema=meta&query=" + query))
        #print tostring(sruResponse, pretty_print=True)
        if sruResponse.xpath("//srw:numberOfRecords/text()", ns)[0] == '0': continue
        collection = sruResponse.xpath("//meta:meta/meta:repository/meta:collection/text()", ns)[0]
        repositoryGroupId = sruResponse.xpath("//meta:meta/meta:repository/meta:repositoryGroupId/text()", ns)[0]
        repository = sruResponse.xpath("//meta:meta/meta:repository/meta:id/text()", ns)[0]
        recordIdentifier = sruResponse.xpath("//meta:meta/meta:record/meta:id/text()", ns)[0]
        parts = sruResponse.xpath("//meta:meta/meta:parts/meta:part/text()", ns)

        ## update-record voorbereiden ##
        meta = makeMeta(collection, repositoryGroupId, repository, recordIdentifier, parts)
        document = makeDocument(meta, tostring(codeBook))
        recordUpdate = makeRequest(action, repository, recordIdentifier, document)
        #print recordUpdate

        ## update-record verzenden ##
        send(recordUpdate)
